package iTunesBackup;

import java.net.URI;
import java.net.URLEncoder;
/**
 * Tune Backup
 * (c) 2007 Gabe Albert
 * Gabe Albert - gabeosx (at) yahoo.com - www.gabealbert.info
 * The use and distribution of this work is subject to the terms of the 
 * GNU GPL license.  A full-text copy of the license is available online at
 * http://www.gnu.org/licenses/gpl.txt
 * @author Gabe Albert
 */
public class MusicTrack {
	private String trackId;
	private String trackName;
	private String trackAlbum;
	private String trackArtist;
	private String trackComposer;
	private String trackGenre;
	private String trackKind;
	private String trackSize;
	private String trackTotalTime;
	private String trackDiscNumber;
	private String trackDiscCount;
	private String trackTrackNumber;
	private String trackTrackCount;
	private String trackYear;
	private String trackDateModified;
	private String trackDateAdded;
	private String trackBitRate;
	private String trackSampleRate;
	private String trackPersistentId;
	private String trackTrackType;
	private String trackFileType;
	private String trackFileCreator;
	private String trackLocation;
	private String trackFileFolderCount;
	private String trackLibraryFolderCount;
	private String trackPlayCount;
	private String trackRating;
	private URI trackBackupLocation;
	private String errorMessage;
	public String getErrorMessage() {
		return errorMessage;
	}
	public void setErrorMessage(String errorMessage) {
		this.errorMessage = errorMessage;
	}
	public String getTrackRating() {
		return trackRating;
	}
	public void setTrackRating(String trackRating) {
		this.trackRating = trackRating;
	}
	public String getTrackPlayCount() {
		if(trackPlayCount==null) 
			return "0";
		else
			return trackPlayCount;
	}
	public void setTrackPlayCount(String trackPlayCount) {
		this.trackPlayCount = trackPlayCount;
	}
	public String getTrackArtist() {
		return trackArtist;
	}
	public void setTrackArtist(String trackArtist) {
		this.trackArtist = trackArtist;
	}
	public String getTrackBitRate() {
		return trackBitRate;
	}
	public void setTrackBitRate(String trackBitRate) {
		this.trackBitRate = trackBitRate;
	}
	public String getTrackComposer() {
		return trackComposer;
	}
	public void setTrackComposer(String trackComposer) {
		this.trackComposer = trackComposer;
	}
	public String getTrackDateAdded() {
		return trackDateAdded;
	}
	public void setTrackDateAdded(String trackDateAdded) {
		this.trackDateAdded = trackDateAdded;
	}
	public String getTrackDateModified() {
		return trackDateModified;
	}
	public void setTrackDateModified(String trackDateModified) {
		this.trackDateModified = trackDateModified;
	}
	public String getTrackDiscCount() {
		return trackDiscCount;
	}
	public void setTrackDiscCount(String trackDiscCount) {
		this.trackDiscCount = trackDiscCount;
	}
	public String getTrackDiscNumber() {
		return trackDiscNumber;
	}
	public void setTrackDiscNumber(String trackDiscNumber) {
		this.trackDiscNumber = trackDiscNumber;
	}
	public String getTrackFileCreator() {
		return trackFileCreator;
	}
	public void setTrackFileCreator(String trackFileCreator) {
		this.trackFileCreator = trackFileCreator;
	}
	public String getTrackFileFolderCount() {
		return trackFileFolderCount;
	}
	public void setTrackFileFolderCount(String trackFileFolderCount) {
		this.trackFileFolderCount = trackFileFolderCount;
	}
	public String getTrackFileType() {
		return trackFileType;
	}
	public void setTrackFileType(String trackFileType) {
		this.trackFileType = trackFileType;
	}
	public String getTrackGenre() {
		return trackGenre;
	}
	public void setTrackGenre(String trackGenre) {
		this.trackGenre = trackGenre;
	}
	public String getTrackId() {
		if(trackId==null)
			return "0";
		else
			return trackId;
	}
	public void setTrackId(String trackId) {
		this.trackId = trackId;
	}
	public String getTrackKind() {
		return trackKind;
	}
	public void setTrackKind(String trackKind) {
		this.trackKind = trackKind;
	}
	public String getTrackLibraryFolderCount() {
		return trackLibraryFolderCount;
	}
	public void setTrackLibraryFolderCount(String trackLibraryFolderCount) {
		this.trackLibraryFolderCount = trackLibraryFolderCount;
	}
	public String getTrackLocation() {
		return trackLocation;
	}
	public void setTrackLocation(String trackLocation) {
		this.trackLocation = trackLocation;
	}
	public String getTrackName() {
		return trackName;
	}
	public void setTrackName(String trackName) {
		this.trackName = trackName;
	}
	public String getTrackPersistentId() {
		return trackPersistentId;
	}
	public void setTrackPersistentId(String trackPersistentId) {
		this.trackPersistentId = trackPersistentId;
	}
	public String getTrackSampleRate() {
		return trackSampleRate;
	}
	public void setTrackSampleRate(String trackSampleRate) {
		this.trackSampleRate = trackSampleRate;
	}
	public String getTrackSize() {
		return trackSize;
	}
	public void setTrackSize(String trackSize) {
		this.trackSize = trackSize;
	}
	public String getTrackTotalTime() {
		if(trackTotalTime==null)
			return "0";
		else
			return trackTotalTime;
	}
	public void setTrackTotalTime(String trackTotalTime) {
		this.trackTotalTime = trackTotalTime;
	}
	public String getTrackTrackCount() {
		return trackTrackCount;
	}
	public void setTrackTrackCount(String trackTrackCount) {
		this.trackTrackCount = trackTrackCount;
	}
	public String getTrackTrackNumber() {
		return trackTrackNumber;
	}
	public void setTrackTrackNumber(String trackTrackNumber) {
		this.trackTrackNumber = trackTrackNumber;
	}
	public String getTrackTrackType() {
		return trackTrackType;
	}
	public void setTrackTrackType(String trackTrackType) {
		this.trackTrackType = trackTrackType;
	}
	public String getTrackYear() {
		return trackYear;
	}
	public void setTrackYear(String trackYear) {
		this.trackYear = trackYear;
	}
	public String getTrackAlbum() {
		return trackAlbum;
	}
	public void setTrackAlbum(String trackAlbum) {
		this.trackAlbum = trackAlbum;
	}
	
	public String getSafeFilePath() {
//		return "/"+stripChars(getTrackArtist())+"/"+stripChars(getTrackAlbum())+"/"+stripChars(getTrackLocation().substring(getTrackLocation().lastIndexOf("/")+1));
		return (
				getGoodString(getTrackArtist())
				+"/"
				+getGoodString(getTrackAlbum())
				+"/"
				+getGoodString(getTrackLocation().substring(getTrackLocation().lastIndexOf("/")+1)))
				.replace("+", "%20");
	}
	
	public static String getGoodString(String badString) {
		if(badString==null || badString=="")
			return "";
		else {
			try {
				return URLEncoder.encode(badString, "UTF-8");
			}
			catch(Exception ex) {
				ex.printStackTrace();
				throw new RuntimeException(ex);
			}
		}
	}
	
	public static String stripChars(String stringToStrip) {
		if(stringToStrip==null)
			return "Unknown";
		try {
			//stringToStrip=stringToStrip.replace("%20", " ");
			stringToStrip=stringToStrip.replace(" ", "%20");
			if(stringToStrip.length()>255) {
				stringToStrip=stringToStrip.substring(0, 254);
			}
			stringToStrip=stringToStrip.replace("/", "");
			stringToStrip=stringToStrip.replace(":", "");
			stringToStrip=stringToStrip.replace("~", "");
		}
		catch(Exception ex) {
			
		}
		return stringToStrip;
	}
	public URI getTrackBackupLocation() {
		return trackBackupLocation;
	}
	public void setTrackBackupLocation(URI trackBackupLocation) {
		this.trackBackupLocation = trackBackupLocation;
	}


}
