/*
 * File:           PropertyListHandlerImpl.java
 * Date:           September 10, 2006  4:04 PM
 *
 * @author  gabe
 * @version generated by NetBeans XML module
 */
package iTunesBackup;
import java.util.HashMap;

import org.xml.sax.*;
/**
 * Tune Backup
 * (c) 2007 Gabe Albert
 * Gabe Albert - gabeosx (at) yahoo.com - www.gabealbert.info
 * The use and distribution of this work is subject to the terms of the 
 * GNU GPL license.  A full-text copy of the license is available online at
 * http://www.gnu.org/licenses/gpl.txt
 * @author Gabe Albert
 */
public class PropertyListHandlerImpl implements PropertyListHandler {

    public static final boolean DEBUG = false;
    private TrackCollection musicCollection;
	
    private int currentMode=-1;
    
    private MusicTrack tempTrack = null;
    
    public HashMap<String, PropertyHandler> handlerCollection;
    
    public PropertyHandler defaultPHandler = new PropertyHandler() {
    	public void execute(MusicTrack tempTrack, String theKey) {
    		if(DEBUG) System.err.println("default handler used");
    	}
    };
    
    PropertyHandler pHandler = defaultPHandler;
    
    public PropertyListHandlerImpl(TrackCollection musicCollection, HashMap<String, PropertyHandler> handlerCollection) {
    	this.musicCollection=musicCollection;
    	this.handlerCollection=handlerCollection;
    }
    
    public void handle_key(final java.lang.String data, final Attributes meta) throws SAXException {
    	if (DEBUG) System.err.println("handle_key: " + data);
    	if(data.equalsIgnoreCase("Track ID")) {
    		tempTrack = new MusicTrack();
    	}
    	try {
    		pHandler = handlerCollection.get(data);
    	}
    	catch(Exception ex) {
    		
    	}
    	if(pHandler==null) {
    		pHandler=defaultPHandler;
    		if(DEBUG) System.out.println("no handler for: "+data);
    	}
    }

    public void start_dict(final Attributes meta) throws SAXException {
        if (DEBUG) System.err.println("start_dict: " + meta);
    }

    public void end_dict() throws SAXException {
        if (DEBUG) System.err.println("end_dict()");
        if(tempTrack!=null && tempTrack.getTrackLocation()!=null) {
        	musicCollection.put(tempTrack);
        	tempTrack=null;
        	if(DEBUG) System.out.println("put track to collection");
        }
    }

    public void handle_string(final java.lang.String data, final Attributes meta) throws SAXException {
        if (DEBUG) System.err.println("handle_string: " + data);
        if(pHandler==null || tempTrack == null) {
        	pHandler=defaultPHandler;
        }
        pHandler.execute(tempTrack, data);
        pHandler=defaultPHandler;
    }

    public void start_plist(final Attributes meta) throws SAXException {
        if (DEBUG) System.err.println("start_plist: " + meta);
    }

    public void end_plist() throws SAXException {
        if (DEBUG) System.err.println("end_plist()");
    }

    public void handle_integer(final java.lang.String data, final Attributes meta) throws SAXException {
        if (DEBUG) System.err.println("handle_integer: " + data);
        if(pHandler==null || tempTrack == null) {
        	pHandler=defaultPHandler;
        }
        pHandler.execute(tempTrack, data);
        pHandler=defaultPHandler;
    }

    public void handle_data(final java.lang.String data, final Attributes meta) throws SAXException {
        if (DEBUG) System.err.println("handle_data: " + data);
    }

    public void handle_true(final Attributes meta) throws SAXException {
        if (DEBUG) System.err.println("handle_true: " + meta);
    }

    public void handle_real(final java.lang.String data, final Attributes meta) throws SAXException {
        if (DEBUG) System.err.println("handle_real: " + data);
    }

    public void handle_date(final java.lang.String data, final Attributes meta) throws SAXException {
        if (DEBUG) System.err.println("handle_date: " + data);
    }

    public void handle_false(final Attributes meta) throws SAXException {
        if (DEBUG) System.err.println("handle_false: " + meta);
    }

    public void start_array(final Attributes meta) throws SAXException {
        if (DEBUG) System.err.println("start_array: " + meta);
    }

    public void end_array() throws SAXException {
        if (DEBUG) System.err.println("end_array()");
    }
}
