package iTunesBackup;

import java.util.*;
/**
 * Tune Backup
 * (c) 2007 Gabe Albert
 * Gabe Albert - gabeosx (at) yahoo.com - www.gabealbert.info
 * The use and distribution of this work is subject to the terms of the 
 * GNU GPL license.  A full-text copy of the license is available online at
 * http://www.gnu.org/licenses/gpl.txt
 * @author Gabe Albert
 */
public class TrackCollection {
	private HashMap<Integer, Integer> keyMapping = new HashMap();
	private HashMap<Integer, MusicTrack> trackMap = new HashMap();
	public Stack<String> dirtyTracks = new Stack();
	private DBPipe dbPipe = new DBPipe();
	public void put(MusicTrack theTrack) {
		if(theTrack.getTrackId()!=null) {
			keyMapping.put(keyMapping.size(), Integer.parseInt(theTrack.getTrackId()));
			trackMap.put(Integer.parseInt(theTrack.getTrackId()), theTrack);
			dbPipe.startConnect();
			int theResult = dbPipe.performAction(theTrack);
			if(theResult==DBPipe.track_isnew)// || theResult==DBPipe.track_updated) intentionally left out until issues of duplicate files are solved (if id3 tags are changed)
			{
				dirtyTracks.push(theTrack.getTrackId());
				//System.out.println("adding to dirty tracks");
			}
		}
	}
	
	/**
	 * Pass your MusicTrack here if getTrackId() will return null
	 * @param theTrack
	 */
	
	public MusicTrack get(int seqNum) {
		if(keyMapping.get(seqNum)==null)
			System.err.println("INVALID: "+seqNum);
		return trackMap.get(keyMapping.get(seqNum));
	}
	
	public MusicTrack getByTrackId(int trackId) {
		return trackMap.get(trackId);
	}
	
	public int size() {
		return keyMapping.size();
	}
	
}
